include     InputTest.inc

BUFFER_LENGTH  = 100
BUFFER_LENGTH2 = 16

.data

message1    db 'Type a string :',13,10,0
message2    db 'Type an integer, x = ',13,10,0
format1     db 'String = %s',13,10,'2 * x + 1 = %d',13,10,0

.data?

string      db BUFFER_LENGTH  dup(?)
integer     db BUFFER_LENGTH2 dup(?)
buffer      db 256 dup(?)

.code

start:

    invoke  StdOut,ADDR message1            ; output a NULL terminated string
    invoke  StdIn,ADDR string,BUFFER_LENGTH ; read keyboard input from console
    invoke  StdOut,ADDR message2
    invoke  StdIn,ADDR integer,BUFFER_LENGTH2
                                            ; StdIn returns the lenght of the input text
    mov     BYTE PTR [integer+eax-2],0      ; remove the CR+LF terminator
    invoke  atodw,ADDR integer              ; convert the decimal string to dword
    shl     eax,1                           ; multiply by 2
    inc     eax                             ; add 1

    invoke  wsprintf,ADDR buffer,ADDR format1,ADDR string,eax
    invoke  StdOut,ADDR buffer
    invoke  ExitProcess,0

END start
